!-----------------------------------------------------------------------
!@***h* PATMOSX/algorithm_constants.f90
!   
! NAME
!   algorithm_constants.f90
! 
! LOCATION
!   .../patmosx/src/algorithm_constants.f90
! 
! PURPOSE
!   This module serves as a common block for passing the 
!   non-cloud algorithm coefficients
! 
! DESCRIPTION
!   This module serves as a common block for passing the 
!   non-cloud algorithm coefficients
!
! AUTHOR
!   Andrew Heidinger, NOAA/NESDIS
! 
! CREATION DATE
!   unk
!
! COPYRIGHT
!   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC DOMAIN AND
!   THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE.  THEY ARE FURNISHED "AS IS." THE 
!   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
!   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
!   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
!   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
!   TO USERS.
!
! NOTES
!   None
!
!@*****
!-------------------------------------------------------------------------
! This module serves as a common block for passing the 
! non-cloud algorithm coefficients
!
! Author: Andrew Heidinger, NOAA/NESDIS
!
! File I/O - none
!
! Public routines: none
!
! Private routines: none
!
!-----------------------------------------------------------------------
module ALGORITHM_CONSTANTS

  use CONSTANTS

  implicit none

!--- NESDIS Sea Surface Temperature
 real(kind=real4),save,public:: a1_day,a2_day,a3_day,a4_day, &
                      a1_night,a2_night,a3_night,a4_night,a5_night,a6_night

!--- Outgoing Longwave Radiation (OLR)
 real(kind=real4),save,public:: win_0,win_1,win_2,win_3,olr_0,olr_1,olr_2,olr_3,olr_4

!--- End of module

end module ALGORITHM_CONSTANTS
