MODULE AWG_Cloud_Mask_Tests
!$Id: awg_cloud_mask_tests.f90,v 1.9 2010/09/23 16:30:44 mfoster Exp $
!--------------------------------------------------------------------
!@***h* PATMOSX/awg_cloud_mask_tests.f90
! 
! NAME
!   awg_cloud_mask_tests.f90
! 
! LOCATION
!   /patmosx/src/awg_cloud_mask_tests.f90
! 
! PURPOSE
!   AWG_Cloud_Mask_Tests
! 
! DESCRIPTION
!   module use statements
!
! AUTHOR
!   Andrew Heidinger, NOAA/NESDIS
! 
! CREATION DATE
!   unk
!
! COPYRIGHT
!   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC DOMAIN AND
!   THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE.  THEY ARE FURNISHED "AS IS." THE 
!   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
!   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
!   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
!   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
!   TO USERS.
!
! NOTES
!   none
!
! EXTERNALS
!  PRIVATE ROUTINES:
!   SPLIT_WIN_CIRRUS_ROUTINE
!   TEMPIR_ROUTINE
!   NIRREF_Chn7_ROUTINE
!   CIRREF_ROUTINE
!   MECIDA_ROUTINE
!   ATMOSPHERIC_SCATTERING_CHN2
!
!  PUBLIC ROUTINES:
!   RUT_ROUTINE
!   TUT_ROUTINE
!   RTCT_ROUTINE
!   ETROP_ROUTINE
!   PFMFT_ROUTINE
!   NFMFT_ROUTINE
!   RFMFT_ROUTINE
!   SET_CMASK_THRESHOLDS
!   RGCT_ROUTINE
!   RVCT_ROUTINE
!   NIRREF_Chn5_ROUTINE
!   EMISS4_ROUTINE
!   ULST_ROUTINE
!
!@*****
!------------------------------------------------------------------------
!
! MODULE name: AWG_Cloud_Mask_Tests
!
! Description:
! module use statements
!
! PRIVATE ROUTINES:
!   SPLIT_WIN_CIRRUS_ROUTINE
!   TEMPIR_ROUTINE
!   NIRREF_Chn7_ROUTINE
!   CIRREF_ROUTINE
!   MECIDA_ROUTINE
!   ATMOSPHERIC_SCATTERING_CHN2
!
! PUBLIC ROUTINES:
!   RUT_ROUTINE
!   TUT_ROUTINE
!   RTCT_ROUTINE
!   ETROP_ROUTINE
!   PFMFT_ROUTINE
!   NFMFT_ROUTINE
!   RFMFT_ROUTINE
!   SET_CMASK_THRESHOLDS
!   RGCT_ROUTINE
!   RVCT_ROUTINE
!   NIRREF_Chn5_ROUTINE
!   EMISS4_ROUTINE
!   ULST_ROUTINE
!--------------------------------------------------------------------
!USE ALGORITHM_MODULE_USAGE
USE CONSTANTS

IMPLICIT NONE

PRIVATE

PUBLIC:: RUT_ROUTINE
PUBLIC:: TUT_ROUTINE
PUBLIC:: RTCT_ROUTINE
PUBLIC:: ETROP_ROUTINE
PUBLIC:: PFMFT_ROUTINE
PUBLIC:: NFMFT_ROUTINE
PUBLIC:: RFMFT_ROUTINE
PUBLIC:: SET_CMASK_THRESHOLDS
PRIVATE:: SPLIT_WIN_CIRRUS_ROUTINE
PRIVATE:: TEMPIR_ROUTINE
PUBLIC:: RGCT_ROUTINE
PUBLIC:: RVCT_ROUTINE
PUBLIC:: NIRREF_Chn5_ROUTINE
PRIVATE:: NIRREF_Chn7_ROUTINE
PRIVATE:: CIRREF_ROUTINE
PRIVATE:: MECIDA_ROUTINE
PUBLIC:: EMISS4_ROUTINE
PUBLIC:: ULST_ROUTINE
PRIVATE:: ATMOSPHERIC_SCATTERING_CHN2

include 'awg_cloud_mask_tests_thresholds.inc'

CONTAINS

include 'awg_cloud_mask_tests_code.inc'



END MODULE AWG_Cloud_Mask_Tests
