	subroutine getnumsc(craft,number)
! * Get "satellite number" for use in r/t code
! .... version of 27.07.06

! * For all spacecraft from TIROSN through METOPC!

! ... Input name may contain any combination of upper and lower case.

! ... NOAA s/c prior to NOAA10 may be input as either noaa0n or noaa-n

! * If given s/c not found, routine returns number = -1

	implicit none
	integer isat,ksat,nsat,number
	integer k,kc,len,nc
	character*6 craft,craftl
	character*3 csat

	parameter (nsat=18)
	character*6 crafts(nsat)
	character cc,char,cm,cz

	data cm/'-'/,cz/'0'/

	data crafts/'tirosn','noaa06','noaa07','noaa08','noaa09',
     +              'noaa10','noaa11','noaa12','noaa13','noaa14',
     +              'noaa15','noaa16','noaa17','noaa18',
     +              'metopa','noaa19','metopb','metopc'/

! Convert spacecraft name to lower case if necessary

	nc=len(craft)
	do k=1,nc
	   cc=craft(k:k)
	   kc=ichar(cc)
	   if(kc.gt.64.and.kc.lt.91) cc=char(kc+32)
	   craftl(k:k)=cc
	enddo
	if(craftl(5:5).eq.cm) craftl(5:5)=cz

! Search list for given spacecraft

	ksat=0
	do isat=1,nsat
	   if(craftl.eq.crafts(isat)) then
	      ksat=isat
	   endif
	enddo

	number=ksat-1

	return
	end
